# Pitaya

Lanceur d'application pour GNU/Linux

## Démarrer avec les sources

### Dépendences de développement

- [NodeJS](https://nodejs.org/) - Dernière version stable, testé sur la 0.12.*
- [NPM](https://www.npmjs.com/) - Normalement automatiquement installé avec NodeJS.

### Initialisation du projet & lancement de Pitaya

```
git clone https://forge.cadoles.com/wpetit/pitaya.git
cd pitaya
git checkout develop
npm install
PITAYA_LOG_LEVEL=debug NODE_ENV=development npm start
```

## Variables d'environnement

Vous pouvez configurer le comportement de Pitaya en passant des variables d'environnement:

| Variable          | Description                            | Valeurs possibles             | Valeur par défaut             |
|-------------------|----------------------------------------|-------------------------------|-------------------------------|
| PITAYA_MODE       | Mode d'exécution de Pitaya             | launcher, edit                | launcher                      |
| PITAYA_PROFILE    | Chemin du fichier profil à charger     | --                            | ./default-profile.json        |
| PITAYA_AS_DESKTOP | Afficher Pitaya en mode "Bureau"       | 1, 0                          | 0                             |
| PITAYA_LOG_FILE   | Enregistrer les logs dans un fichier   | Chemin absolu vers un fichier | aucune (pas d'enregistrement) |
| PITAYA_LOG_LEVEL  | Niveau de log                          | debug, info, error, fatal     | info                          |

## Comment construire l'application depuis les sources

```
npm run build
```

Un dossier `pitaya-<target>-<arch>` sera créé dans le répertoire `./build`. Celui ci contient tous les fichiers nécessaires à l'application.


## Comment contribuer

Ce projet utilise la méthodologie [Git Flow](http://nvie.com/posts/a-successful-git-branching-model/).

## Licence

GPLv3
