var Util = require('../../util');

var LOAD_PROFILE = exports.LOAD_PROFILE = 'LOAD_PROFILE';
var LOAD_PROFILE_SUCCESS = exports.LOAD_PROFILE_SUCCESS = 'LOAD_PROFILE_SUCCESS';
var LOAD_PROFILE_FAILED = exports.LOAD_PROFILE_FAILED = 'LOAD_PROFILE_FAILED';

exports.loadProfile = function(profilePath) {

  return function(dispatch, getState) {

    dispatch({ type: LOAD_PROFILE, profilePath: profilePath });

    Util.Logger.info('Loading profile "%s"', profilePath);

    return Util.System.loadJSON(profilePath)
      .then(function(profile) {
        Util.Logger.info('Profile loaded.');
        dispatch({ type: LOAD_PROFILE_SUCCESS, profile: profile });
        return profile;
      })
      .catch(function(err) {
        dispatch({ type: LOAD_PROFILE_FAILED, error: err });
        return err;
      })
    ;

  };

};
