var ipc = require('ipc');
var isMainProcess = process.type === 'browser';

var QUIT_CMD = 'app-util:quit';

exports.quit = function(exitCode) {
  if(isMainProcess) {
    process.exit(exitCode);
  } else {
    ipc.send(QUIT_CMD, exitCode);
  }
};

// Main process, setup listeners
if(isMainProcess) {

  ipc.on(QUIT_CMD, function(evt, exitCode) {
    exports.quit(exitCode);
  });

}
